=== Makefile ===
SRC_DIR := src
SRC_FILES := $(wildcard $(SRC_DIR)/*.mm)
SRC_FILES := $(wildcard $(SRC_DIR)/*.cc)
SRC_FILES := $(wildcard $(SRC_DIR)/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/android/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/android/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/cli/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/cli/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/core/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/core/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/crypto/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/crypto/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/freedesktop/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/freedesktop/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.c)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk4/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk4/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/qt6/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/qt6/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/harmony/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/harmony/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/i18n/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/i18n/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/extensions/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/extensions/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/net/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/net/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/server/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/server/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/win32/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/win32/*.hpp)
all: $(SRC_FILES)
	clang-format --style file -i $(SRC_FILES)
