=== debian/changelog ===
yass (1.20.4-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 2 Jan 2026 15:16:25 +0800

yass (1.20.3-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
  * add debian loong64 port (cli)
  * add debian riscv64 port (gtk3)
 -- Chilledheart <hukeyue@vip.163.com>  Mon, 29 Dec 2025 17:50:23 +0800

yass (1.20.2-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 26 Dec 2025 13:21:58 +0800

yass (1.20.1-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 12 Dec 2025 20:02:57 +0800

yass (1.20.0-1) UNRELEASED; urgency=medium

  * bump to chromium 144 dependents.
  * license: make source code CDDL-1.0 compatible
 -- Chilledheart <hukeyue@vip.163.com>  Mon, 8 Dec 2025 17:56:56 +0800

yass (1.17.2-1) UNRELEASED; urgency=medium
  * tls: correct ECDSA verification for FIPS.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 18 Sep 2025 11:32:53 +0800

yass (1.17.1-1) UNRELEASED; urgency=medium
  * undocumented changes.

 -- Chilledheart <hukeyue@vip.163.com>  Wed, 17 Sep 2025 11:41:28 +0800

yass (1.17.0-1) UNRELEASED; urgency=medium

  * bump to chromium 141 dependents.
  * net: replace folly::IOBuf with google::IOBuffer.
  * tls: enable ML-KEM on all platforms by installation.
  * undocumented changes.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 16 Sep 2025 20:55:15 +0800

yass (1.16.2-1) UNRELEASED; urgency=medium

  * cli: reduce memory usage per connection.
  * base: use DCHECK_IS_ON for check_op.
  * net: handle ip-address like hostname correctly.
  * net: listen to EPOLLRDHUP/POLLRDHUP events.
  * net: fix ssl socket re-use issus when trying different endpoint.
  * net: avoid already_open error when opening next endpoint.
  * tls: load very first ca-bundle file only.
  * tls: update for fedora and rhel update.

 -- Chilledheart <hukeyue@vip.163.com>  Sun, 1 Dec 2024 09:44:59 +0800

yass (1.16.1-1) UNRELEASED; urgency=medium

  * tls: add adjust system trusted CA folder for linux.
  * tls: --capath now accepts separated list of directories.
  * cli: handle http/1.1 keepalive for different host properly.
  * cli: increase nofile to 65536 (systemd).
  * network: increase parallel_max to 65535.
  * network: apply keep alive on connections between client and browsers.
  * tls: use builtin ca store universally.
  * tls: ship GTS Root R4 with supplementary ca.

 -- Chilledheart <hukeyue@vip.163.com>  Mon, 18 Nov 2024 16:48:23 +0800

yass (1.16.0-1) UNRELEASED; urgency=medium

  * bump to chromium 132 dependents.
  * build: add an option to enable/disable assertions.
  * core: move logging and other modules to googleurl.
  * http2: handle HTTP/2 status code in response.
  * http2: handle HTTP/2 Push as soft error.
  * tls: enable reusable sessions.
  * tls: enable post quantum option for server-side.
  * tls: support both of mlkem and kyber for server-side.
  * tls: enable ALPS for HTTP/2 only.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 12 Nov 2024 12:17:34 +0800

yass (1.15.4-1) UNRELEASED; urgency=medium

  * cli: reduce memory usage per connection.
  * base: use DCHECK_IS_ON for check_op.
  * net: handle ip-address like hostname correctly.
  * net: listen to EPOLLRDHUP/POLLRDHUP events.
  * net: fix ssl socket re-use issus when trying different endpoint.
  * net: avoid already_open error when opening next endpoint.
  * tls: load very first ca-bundle file only.
  * tls: update for fedora and rhel update.
  * tls: add adjust system trusted CA folder for linux.
  * tls: --capath now accepts separated list of directories.
  * cli: handle http/1.1 keepalive for different host properly.
  * cli: increase nofile to 65536 (systemd).
  * network: increase parallel_max to 65535.
  * network: apply keep alive on connections between client and browsers.
  * tls: use builtin ca store universally.
  * tls: ship GTS Root R4 with supplementary ca.
  * http2: handle HTTP/2 status code in response.
  * tls: enable reusable sessions.

 -- Chilledheart <keeyou-cn@outlook.com>  Fri, 1 Nov 2024 09:44:59 +0800

yass (1.15.3-1) UNRELEASED; urgency=medium

  * http2: handle HTTP/2 Push as soft error.

 -- Chilledheart <hukeyue@vip.163.com>  Wed, 30 Oct 2024 09:46:13 +0800

yass (1.15.2-1) UNRELEASED; urgency=medium

  * some trivial changes.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 24 Oct 2024 11:08:12 +0800

yass (1.15.1-1) UNRELEASED; urgency=medium

  * build: add an option to enable/disable assertions.
  * tls: enable post quantum option for server-side.
  * tls: support both of mlkem and kyber for server-side.
  * tls: enable ALPS for HTTP/2 only.
  * core: move logging and other modules to googleurl.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 24 Oct 2024 10:36:37 +0800

yass (1.15.0-1) UNRELEASED; urgency=medium

  * bump to chromium 131 dependents.
  * net: optimize yield algorithm.
  * net: fix http proxy integration with qt 6.8.
  * tls: support and enable ML-KEM by default.
  * tls: support post quantumn key-agreements in server side.
  * tls: fix crash due to dangling DoPeek call.
  * cli: add stats for yield event.
  * systemd: update sample config files.
  * systemd: increase RestartSec to 5s.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 15 Oct 2024 13:04:44 +0800

yass (1.14.4-1) UNRELEASED; urgency=medium

  * net: fix http proxy integration with telegram.
  * qt: fix translation with post quantumn key-agreements.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 10 Oct 2024 18:31:24 +0800

yass (1.14.3-1) UNRELEASED; urgency=medium

  * tls: support and enable ML-KEM by default.
  * tls: support post quantumn key-agreements in server side.
  * tls: fix crash due to dangling DoPeek call.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 8 Oct 2024 12:53:13 +0800

yass (1.14.2-1) UNRELEASED; urgency=medium

  * systemd: update sample config files.

 -- Chilledheart <hukeyue@vip.163.com>  Sun, 6 Oct 2024 10:01:41 +0800


